#pragma once

#include "prelude.hpp"
#include "begin.hpp"
#include "end.hpp"
#include "epsilon.hpp"

namespace biscuit
{

template<
	class Parser
>
struct kleene_star
{
	template< class State >
	static bool parse(State &state)
	{
		while (Parser::parse(state))
			;

		return true;
	}
};

// meaningless
template<>
struct kleene_star<begin>;

template<>
struct kleene_star<end>;

template<>
struct kleene_star<epsilon>;

} // namespace biscuit
